; *************************************** 
; * Demo 16C84 Program by Edward Cardew * 
; *        Edward_Cardew@aia.com        * 
; * Program only for non commercial use * 
; ***************************************   
   
; ***************************************
; * Modifitseeritud veidi				*
; * Felch (felc@edu.ttu.ee)             *
; * teha:                               *
; * - 5*ksu kontroll - tehtud	    	*
; * - kella nit						*
; * - hirete mlu koos kellaajaga		*
; * 18.oktoober 2003                    *
; ***************************************    
	INCLUDE "PIC16C84.INC" 
 	__CONFIG _XT_OSC & _PWRTE_ON & _WDT_OFF & _CP_OFF    
	
; ***** Variaablid *****    
RAMbase         equ     12            
	cblock  	RAMbase                 
				large_count                 
				small_count                 
				flags                 
				temp                 
				LCD_Count                 
				Key_Press                 
				RS232_Chr                 
				Table_Temp 
				Messi_nr                
				W_Temp                 
				S_Temp                 
				T_Temp                 
				Old_T_Temp                 
				RC5_Bit_Count                 
				RC5_Command                 
				RC5_Address
				Kasuloendi
				Viimane_Kask
				Viimane_Aadr
				Piiksu_loendi         
				temp_2  
		endc 

; ***** raud ****
#define	Piiks			PORTA,0					; piesosummer
#define	SDA				PORTA,0					; samas ka kella kivi data otc
#define	SCL				PORTA,1					; kella kivi taktiotc
#define	LED				PORTA,1					; samas ka LED'i otc
#define KOMP            PORTA,4                 ; Toite komparaatori sisend 0=OK 1=pinge madal 
#define RS              PORTA,3                 ; LCD R/S Line 0=ctrl 1=data 
#define E               PORTA,2                 ; LCD Enable otc
#define S1				PORTB,1					; Nupp S1
#define S2				PORTB,2					; Nupp S2
#define RS232_TX		PORTB,3					; Saade arvuti RS-232 porti

; LCD data otsad:  
;PIC----LCD
;----------
;PB4 -> D4
;PB5 -> D5
;PB6 -> D6
;PB7 -> D7
;LCD D0..D3 hendamata!

; ***** igat masti lipud *****  
#define LCD_Mode        flags,0                 ; 0=Control, 1=Data 
#define Last_RC5_Bit    flags,1                 ; Last RC5 bit received 
#define RC5_2nd_Bit     flags,2                 ; Add 2 RC5 bits 
#define RC5_2nd_Value   flags,3                 ; 2nd RC5 bit received 
#define RC5_Bit         flags,4                 ; 1st RC5 bit received 
#define alarm	        flags,5                 ; oli hire 
#define SEL_BANK_0      bcf     STATUS,RP0      ; Select Bank 0 
#define SEL_BANK_1      bsf     STATUS,RP0      ; Select Bank 1 
#define CARRY           STATUS,C 
#define ZERO            STATUS,Z 

;seadmete aadressid
#define aadress			1Dh						; Sellise aadresiga saadab Kerberose saatja pakette teele. IR-pultidel on aadr.=0 (tavaliselt)

;saadetavad teated
#define uks				01h						; ukseandur andis hiret
#define patarei			02h						; saatja patarei thi
#define liigub			03h						; liikumisandur andis hiret
#define levi			04h						; vajutati levi testi/hire klahvi
#define TESTTIMES		d'5'					; niimitu korda laseme teadet saata ja vrrelda enne kra tstmist
;lisaks saadetakse PC-le RS-232 porti pidi need teated:
#define Juuser_reag		00h						; Kasutaja vajutas nupule S1 (vttis hire teatavaks ja lx nuga ocima ;)
#define Bat_tyhi		05h						; vastuvtja patarei thjeneb

; ***** RESET *****          
				org     0000h 
Reset_Vector         
				call    Beep  		 			; Indicate Reset was OK         
				call    Init_LCD         		; Initialise LCD         
				call    Init_RC5         		; Initialise RC5         
				goto    Main_Start       		; Skip Interrupt Routines  
; ***** INTERRUPT *****  
Interrupt_Vector         
				org     0004h 
Push    		movwf   W_Temp           		; Save W         
				swapf   STATUS,W         
				movwf   S_Temp           		; Save STATUS         
				SEL_BANK_0 
Disable_Int     bcf     INTCON,GIE       		; Disable all Interrupts         
				btfsc   INTCON,GIE       		; Are Interrupts disabled ?         
				goto    Disable_Int      		; NO, try again          
				btfsc   INTCON,INTF      		; Skip PORTB0/Interrupt?         
				goto    RB0_Int          		; NO, goto RB0          
				btfsc   INTCON,T0IF      		; Skip Timer Overflow Interrupt ?         
				goto    Timer_Int        		; NO, goto Timer Interrupt  
Pop     		swapf   S_Temp,W         
				movwf   STATUS           		; Return STATUS         
				swapf   W_Temp,F         
				swapf   W_Temp,W         		; Return W         
;				bcf     INTCON,T0IF     		; Clear Overflow       
;				bsf     INTCON,T0IE        		; Timer Interrupts'id lubatud
				retfie                   		; Return setting GIE  

; ***** RB0/INT RC5 Interrupt *****  
RB0_Int         bsf     Piiks         
				bcf     INTCON,T0IE      		; Disable further Timer0 Interrupts         
				bcf     INTCON,T0IF      		; Clear Overflow Flag          
				movf    TMR0,W           		; Get Timer Value                 
				movwf   T_Temp           		; And rescue          
				movlw   b'00000011'      		; W takes 1:16         
				clrf    TMR0         
				SEL_BANK_1         
				iorwf   OPTION_REG,F     		; 1:16         
				SEL_BANK_0          
				bcf     RC5_2nd_Bit  
; ***** First Bit ??? ******          
				movf    RC5_Bit_Count,F         
				btfsc   ZERO         
				goto    RC5_Add_1  
; ***** Decide which window contains T_Temp [ <> 8C <> CF <> ]           
				movlw   h'8C'         
				subwf   T_Temp,W         		; Carry will be cleared if T_Temp < 8C ie 2T         
				btfss   CARRY                   ; Skip if >= 8C         
				goto    Timer_is_2T  	 
; must be >= 8C          
				movlw   h'CF'            		; Idem with CF         
				subwf   T_Temp,W         
				btfss   CARRY         
				goto    Timer_is_3T  
Timer_is_4T         
				btfss   Last_RC5_Bit     		; Was last bit "1" ?         
				goto    RC5_Rx_Error     		; No, was "0", error!         
				goto    RC5_Add_01       		; Last bit was "1", add "01"  
Timer_is_2T         
				btfss   Last_RC5_Bit     		; Was last bit "1" ?         
				goto    RC5_Add_0        		; No, was "0", add "0"         
				goto    RC5_Add_1        		; No, was "1", add "1"  
Timer_is_3T         
				btfss   Last_RC5_Bit     		; Was last bit "1" ?         
				goto    RC5_Add_1        		; No, was "0", add "1"         
				goto    RC5_Add_00       		; Last bit was "1", add "00"  
; ***** If Two Bits must be added, the first one is always a 0  
RC5_Add_01         
				bsf     RC5_2nd_Value         
				goto    RC5_Add_0X  
RC5_Add_00         
				bcf     RC5_2nd_Value  
RC5_Add_0X         
				bsf     RC5_2nd_Bit  
RC5_Add_0         
				bcf     RC5_Bit         
				goto    RC5_Add_Bit  
RC5_Add_1         	
				bsf     RC5_Bit  
RC5_Add_Bit         
				bcf     Piiks     
     
				btfss   RC5_Bit          			; Save bit for future         
				goto    RC5_was_0
				bsf     Last_RC5_Bit 
				goto    RC5_Test_End 
RC5_was_0                                       
         		bcf     Last_RC5_Bit                   
RC5_Test_End                                    
				incf    RC5_Bit_Count,F  			; Increment Bit Count
			    movlw   d'2'             			; Test if RC5 bit extended (bit 2)         
				subwf   RC5_Bit_Count,W
			    btfsc   ZERO             			; If extended bit then         
				goto    RC5_Command_Rotate			; add extended bit to Command
; testi nd bitti 3, see on new key pressed - vi ei tasuks?
			    movlw   d'9'             			; Test Bit Count for >= 9         
				subwf   RC5_Bit_Count,W  			; Carry will be set if >= 9         
				btfss   CARRY            			; Skip if >= 9  ehk kui >=9, on tegemist ksubitiga
;				;goto    RC5_Add_Bit_End  
				goto	  RC5_check_adr
RC5_Command_Rotate         
				rlf     RC5_Command      			; RC5 Command Section         
				bcf     RC5_Command,0         
				btfsc   RC5_Bit          			; Skip next if 0         
				bsf     RC5_Command,0  
RC5_Add_Bit_End         
				btfss   RC5_2nd_Bit      			; Add two bits ?         
				goto    RC5_Int_End      			; No, End Interrupt         
				bcf     RC5_2nd_Bit      			; Two bits, now one bit!         
				btfsc   RC5_2nd_Value    			; Second bit is 0 ?         
				goto    RC5_Add_1        			; No, add a 1         
				goto    RC5_Add_0        			; Yes, add a 0  
RC5_Rx_Error  
RC5_Int_End             
				bsf     INTCON,T0IE      			; Enable Timer0 Interrupts         
				bcf     INTCON,INTF      			; Clear Interrupt PortB Flag         
				goto    Pop              			; Quit via POP  
RC5_check_adr
				movlw   d'4'		 	 			; kas vastu vetud biti jrk.nr. >=4?
				subwf   RC5_Bit_Count,W  			; Carry set kui >= 4         
				btfss   CARRY            			; Skip if >= 4  ehk kui >=4, on tegemist aadressi bittidega       
				goto	RC5_Add_Bit_End  			; olidki startbitid
RC5_Address_Rotate
				rlf     RC5_Address      			; RC5 Aadressi Sektsioon         
				bcf     RC5_Address,0         
				btfsc   RC5_Bit          			; Skip next if 0         
				bsf     RC5_Address,0  
				goto	RC5_Add_Bit_End  
				

Timer_Int                               			; RC5 Time of the Truth         
				bcf     INTCON,T0IE     			; Disable further Timer0 Interrupts         
				bcf     INTCON,T0IF     			; Clear Overflow       
   
				movlw   d'13'           			; Test Bit Count = 13         
				subwf   RC5_Bit_Count,W 			; Zero will be set if Count = 13         
				btfss   ZERO            			; Skip if = 13, will need to add a 0         
				goto    No_Zero_Needed         
				incf    RC5_Bit_Count,F 			; Increment Bit Count         
				rlf     RC5_Command     			; RC5 Command Section         
				bcf     RC5_Command,0  

No_Zero_Needed         
				movlw   b'01000000'     			; Do some cosmetics:         
				xorwf   RC5_Command,F   			; Put extended above normal commands  
; RC5 Gimmicks         
     
				movlw   d'14'           			; Test Bit Count = 14 ;       
				subwf   RC5_Bit_Count,W 			; Zero will be set if Count = 14 ;       
				btfss   ZERO            			; Skip if = 14, do normal ;       
				goto    RC5_was_Err     			; Error display 
         
				
				movlw	d'0'						; mitu korda ksk saadud ?
				subwf   Kasuloendi,W
				btfsc	ZERO						; esimene kord ?
				goto    esimene_kask				; mnjah

				movf	Viimane_Aadr,W				; kas aadress sama mis eelmises ksus ?
				subwf   RC5_Address,W   
				btfss   ZERO            			; null, kui ok
				goto	lopetame					; erinevad -> jama majas, ra siit
				movlw   TESTTIMES					; 5* sama ksk vastu vetud ?
				subwf   Kasuloendi,W
				btfsc	ZERO						; ongi nii ?
				goto    dekodeeri					; mnjah, tundub kll. Vaatame mis nad tahavad...
				goto	veel_kaske					; vara veel...

esimene_kask
				movf    RC5_Address,W   			; Geti saadud aadress         
				movwf   Viimane_Aadr				; jta meelde
				movf    RC5_Command,W   			; Geti saadud ksk         
				movwf   Viimane_Kask				; jta meelde
veel_kaske
				incf	Kasuloendi					; kasvata ksuloendit
				goto	RC5_Timer_Reset 			; ootab uut ksku


lopetame
				clrf    Kasuloendi      			; ksk edukalt vastu vetud, puhasta registrid saastast   
				clrf    Viimane_Kask         
				clrf    Viimane_Aadr         
				goto	RC5_Timer_Reset 			; ootab uut ksku


dekodeeri
; kas meie aadress?
				movlw	aadress						; Kerberose aadress
				subwf   RC5_Address,W   			; Zero kui on meie aadress
				btfsc   ZERO
				goto	Dekodeeri_kask
				goto	RC5_Timer_Reset
Dekodeeri_kask
				movlw   uks							; ukse anduri hire?
				subwf   RC5_Command,W
				btfss	ZERO
				goto	Dek_1
				movwf	RC5_Command
				call	Send_RS232					; saada seriali ka
				bcf     LCD_Mode        			; Tekst lheb         
				movlw   b'10000000'     			; LCD rea 1 algusest alates
				call    Send_LCD        	      
				movlw   11h         
				movwf   Messi_nr	             
				call    Text_1          			; Teade "ukse andur"
				bsf		alarm
				bcf		LED
				goto    RC5_Timer_Reset 
Dek_1
				movlw   patarei						; saatja patarei thi?
				subwf   RC5_Command,W
				btfss	ZERO
				goto	Dek_2
				movwf	RC5_Command
				call	Send_RS232					; saada seriali ka
				bcf     LCD_Mode        			; Tekst lheb         
				movlw   b'10000000'     			; LCD rea 1 algusest alates
				call    Send_LCD        	      
				movlw   33h         
				movwf   Messi_nr	             
				call    Text_1          			; Teade "saatja patarei thi"
				bsf		alarm
				bcf		LED
				goto    RC5_Timer_Reset 
Dek_2
				movlw   liigub						; liikumisanduri hire?
				subwf   RC5_Command,W
				btfss	ZERO
				goto	Dek_3
				movwf	RC5_Command
				call	Send_RS232					; saada seriali ka
				bcf     LCD_Mode        			; Tekst lheb         
				movlw   b'10000000'     			; LCD rea 1 algusest alates
				call    Send_LCD        	      
				movlw   22h         
				movwf   Messi_nr	             
				call    Text_1          			; Teade "PIR andur"
				bsf		alarm
				bcf		LED
				goto    RC5_Timer_Reset 
Dek_3
				movlw   levi						; levi test/hire?
				subwf   RC5_Command,W
				btfss	ZERO
				goto	RC5_Timer_Reset
				movwf	RC5_Command
				call	Send_RS232					; saada seriali ka
				bcf     LCD_Mode        			; Tekst lheb         
				movlw   b'10000000'     			; LCD rea 1 algusest alates
				call    Send_LCD        	      
				movlw   55h         
				movwf   Messi_nr	             
				call    Text_1          			; Teade "levi test"
				bsf		alarm
				bcf		LED


RC5_was_Err         
;; Reset RC5 variables  
RC5_Timer_Reset         	
				bsf     Last_RC5_Bit         
				clrf    RC5_Bit_Count         
				clrf    RC5_Command    				; valmistume uueks ksuks          
				clrf    RC5_Address          
				goto    Pop            				; Quit via POP 

; ************************* 
; ***** Main Program ****** 
; *************************  
Main_Start         
				call    LCD_Graph       		; Define LCD Graphics          
				call    Beep  

				bcf     LCD_Mode        		; Tekst lheb         
				movlw   b'11000000'     		; LCD rea 2 algusest alates
				call    Send_LCD        	      

				movlw   0h         
				movwf   Messi_nr	             
				call    Text_1          		; Teade "Kerberos valvab"
				bsf		LED
ml1	
				bcf		alarm					; hireid ei ole
				movlw   55h         
				movwf   Piiksu_loendi	             
main_loop         
				SEL_BANK_1              		; Prepare Ports for Keys         
				bcf     OPTION_REG,NOT_RBPU     ; Turn on Pullup         
				movlw   b'11110000'     		; Port B top Nibble Input         
				iorwf   TRISB,1         		; Set port B<4..7> to input         
				SEL_BANK_0         
 
				btfss	S1						; loe nupu S1 seisu
				call	clear_alarm				; vajutatud -> kustuta alarmi kiri
				btfss	S2						; loe nupu S2 seisu
				call	Nupp_2
				btfsc	KOMP					; patarei normis?
				call	Battery					; eip ole!
; 2. rea pos. 16 tuleb keerlev krnks mis nitab et prose ikka hingab veel ega ole kokku jooksnud       
				bcf     LCD_Mode        			; Control         
				movlw   b'11001111'     			; Pos 16         
				call    Send_LCD         
				bsf     LCD_Mode        			; Text         
				movlw   0         
				call    Send_LCD         
				call    Long_Wait 
                
				bcf     LCD_Mode        			; Control         
				movlw   b'11001111'     			; Pos 16         
				call    Send_LCD         
				bsf     LCD_Mode        			; Text         
				movlw   1         
				call    Send_LCD         
				call    Long_Wait  
                
				bcf     LCD_Mode        			; Control         
				movlw   b'11001111'     			; Pos 16         
				call    Send_LCD      
    
				bsf     LCD_Mode        			; Text         
				movlw   2         
				call    Send_LCD         
				call    Long_Wait   
               
				bcf     LCD_Mode        			; Control         
				movlw   b'11001111'     			; Pos 16         
				call    Send_LCD         
				bsf     LCD_Mode        			; Text         
				movlw   3         
				call    Send_LCD         
				call    Long_Wait   
  				btfsc	alarm						; hire oli?
 				goto	piiksume    
				goto    main_loop  
piiksume	
				decfsz	Piiksu_loendi				; aitab kisast?
				goto	piiksume_1
				goto    ml1 
piiksume_1
				call	Beep
				goto    main_loop  
clear_alarm
				movlw	Juuser_reag					; number null teatab PC-le et juuser reageeris alarmile
				call	Send_RS232					; saada seriali ka
				bcf     LCD_Mode        			; Tekst lheb         
				movlw   b'10000000'     			; LCD rea 1 algusest alates
				call    Send_LCD        	      
				movlw   66h         
				movwf   Messi_nr	             
				call    Text_1          			; Thi rida
				bcf		alarm						; kisa ra
				movlw   55h         
				movwf   Piiksu_loendi	             
				bsf		LED
				return
Nupp_2			; siia ka mingi tegevus
				return
Battery
				movlw	Bat_tyhi					; teatab PC-le et patarei on thjavitu
				call	Send_RS232					; saada seriali ka
				bcf     LCD_Mode        			; Tekst lheb         
				movlw   b'10000000'     			; LCD rea 1 algusest alates
				call    Send_LCD        	      
				movlw   44h         
				movwf   Messi_nr	             
				call    Text_1          			; Teade "Patarei thjeneb"
				return

; dump koodi ei kasuta praegu
DUMP         
				movlw   d'30'         
				movwf   LCD_Count 
DUMP_L         
				movf    LCD_Count,W         
				movwf   FSR         
				movf    INDF,W         
				call    HEX2RS232         
				incf    LCD_Count,F         
				movf    LCD_Count,W         
				sublw   d'45'         
				btfsc   ZERO         
				goto    ELP         
				goto    DUMP_L  
ELP     
				goto    ELP   
; *********************** 
; ***** Subroutines ***** 
; ***********************  
; ***** Initialise RC5 *****  
Init_RC5          
				bsf     Last_RC5_Bit         
				clrf    RC5_Bit_Count         
				clrf    RC5_Command  
				clrf    Kasuloendi         
				clrf    Viimane_Kask         
				clrf    Viimane_Aadr         
; ***** Set up Timer for RC5         
				SEL_BANK_0         
				bcf     INTCON,T0IE				; No Timer Interrupts         
				clrwdt                    		; Clear WDT         
				SEL_BANK_1         
				movlw   0h;b'11010000'         
;				andwf   OPTION_REG,F      		; Clear Timer Options 
				movwf	OPTION_REG
         
				SEL_BANK_1         
				bcf     OPTION_REG,INTEDG 		; Interrupt on falling  edge (eg. SFH505) 
;       			bsf     OPTION_REG,INTEDG 	; Interrupt on rising  edge (eg. TDA3047)         
				bsf	  	Piiks	  				; Piiksu juhtimise otc krgeks (passiivne nivoo)
				bsf	  	SCL			  			; kellakivi SCL otc krgeks (passiivne nivoo)
				SEL_BANK_0          

				bsf     INTCON,INTE       		; Enable RB0/INT         
				bsf     INTCON,GIE        		; Enable Interrupts Global         
				return  

; ***** Send a HEX byte in W to LCD *****  

HEX2LCD         
				movwf   temp_2         
				swapf   temp_2,W         
				call    Nibble2ASCII         
				call    Send_LCD         
				movf    temp_2,W         
				call    Nibble2ASCII         
				call    Send_LCD         
				return  

; ***** Send a HEX byte in W to RS232 *****  

HEX2RS232         
				movwf   temp_2         
				swapf   temp_2,0         
				call    Nibble2ASCII         
				call    Send_RS232         
				movf    temp_2,0         
				call    Nibble2ASCII         
				call    Send_RS232         
				movlw   #" "         
				call    Send_RS232         
				return  

; ***** Convert Nibble to ASCII Hex Digit *****  
Nibble2ASCII         
				andlw   h'0F'         
				addlw   h'F6'         
				btfsc   CARRY         
				addlw   h'07'         
				addlw   h'3A'         
				return  

; ***** RS232 Send W via Port B3 *****  
Send_RS232         
				movwf   RS232_Chr         
				SEL_BANK_1         
				bcf     TRISB,3         		; Set port B3 to output         
				SEL_BANK_0   
       
				movlw   08h         
				movwf   large_count     		; 8 Bits to send
          
				bsf     RS232_TX        		; Send Start Bit         
				call    Wait_Bit  

Send_RS232_Loop         
				btfsc   RS232_Chr,0         
				goto    RS232_TX_1         
				goto    RS232_TX_0  

RS232_TX_1         
				bcf     RS232_TX         
				goto    RS232_Cont  
RS232_TX_0         
				bsf     RS232_TX         
				goto    RS232_Cont  
RS232_Cont         
				call    Wait_Bit         
				rrf     RS232_Chr,1         
				decfsz  large_count,1         
				goto    Send_RS232_Loop          

				bcf     RS232_TX         
				call    Wait_Bit          
				return   

; ***** Define LCD Graphics ******  
LCD_Graph         
				bcf     LCD_Mode        		; Control Mode
                  
				movlw   b'01000000'     		; CGRAM set to 0         
				call    Send_LCD        
  
				bsf     LCD_Mode        		; Data Mode
          
				clrf    LCD_Count 
LCD_Graph_L         
				movf    LCD_Count,0         
				call    GraphDef         
				call    Send_LCD         
				incf    LCD_Count,1         
				movf    LCD_Count,0         
				sublw   d'32'         
				btfsc   ZERO         
				return         
				goto    LCD_Graph_L           

				call    GraphDef         
				call    Send_LCD         
				decfsz  large_count,1         
				goto    LCD_Graph_L         
				return       

; ***** Send some Text *****  
Text_1         
				clrf    LCD_Count   			; LCD_Count=0      
				bsf     LCD_Mode        		; Text Mode 
Text_1_L         
				movf    LCD_Count,0				; LCD_Count->W         
				call    Message         
				call    Send_LCD    			; W->LCD-le koos Enable pulsiga      
				incf    LCD_Count,1         	; jrgmine smbol
				movf    LCD_Count,0         
				sublw   d'16'         
				btfsc   ZERO         
				return         
				goto    Text_1_L     
; ***** Send Data to LCD ***** 
; ***** Data is in W register  
Wait_Send_LCD         
				movwf   temp         
				call    Wait_2ms         
				movf    temp,W 
Send_LCD         
				movwf   temp            		; Save W         
				call    Init_Port_LCD   		; Initialise Ports for LCD         
				bcf     RS              		; Set to Control Mode         
				btfsc   LCD_Mode        		; Skip Data Mode if LCD_Mode = 0         
				bsf     RS         
				movf    temp,W         
				call    Toggle_E         
				swapf   temp,W             
				call    Toggle_E         
				bcf     RS         
				call    Wait_60us         
				return  
; ***** Initialize LCD *****  
Init_LCD         
				call    Wait_2ms        		; Let Voltages Settle         
				bcf     LCD_Mode        		; LCD Control Mode         
				call    Init_Port_LCD   		; Initialise Ports         
				clrf    PORTA           		; Port  A low         
				bcf     RS         
				movlw   b'00110000'     		; Set 8 bit interface         
				call    Wait_Toggle_E                  
				movlw   b'00110000'     		; Set 8 bit interface         
				call    Wait_Toggle_E          
				movlw   b'00110000'     		; Set 8 bit interface         
				call    Wait_Toggle_E          
				movlw   b'00100000'     		; Set 4 bit interface         
				call    Wait_Toggle_E          
				movlw   b'00101000'     		; 4 bit  2 line  5x7         
				call    Wait_Send_LCD          
				movlw   b'00001000'     		; Display all off         
				call    Wait_Send_LCD                  
				movlw   b'00000001'     		; Clear Display (Takes Time)         
				call    Wait_Send_LCD          
				movlw   b'00000110'     		; Cursor increment  no Shift         
				call    Wait_Send_LCD          
				movlw   b'00001100'     		; Disp On  Cursor Off  Blink On         
				call    Wait_Send_LCD          
				movlw   b'00101000'     		; 4 bit  2 line  5x7         
				call    Wait_Send_LCD          
				return  
; ***** Initialise Ports for LCD *****  
Init_Port_LCD         
				SEL_BANK_1              		; Prepare Ports for LCD 
				bcf     TRISB,4         
				bcf     TRISB,5         
				bcf     TRISB,6         
				bcf     TRISB,7         
				bcf     TRISA,2         		; Set Port A,2 (E) to output         
				bcf     TRISA,3         		; Set Port A,3 (RS) to output         
				SEL_BANK_0         
				return  
; ***** Latch Data into LCD ***** 
Wait_Toggle_E         
				movwf   temp         
				call    Wait_2ms         
				call    Wait_2ms         
				call    Wait_2ms         
				call    Wait_2ms         
				movf    temp,W 
Toggle_E         
				andlw   b'11110000'     		; Do not disturb other ports         
				movwf   PORTB         
				bsf     E         
				bcf     E         
				return  
; ***** Long Wait *****  
Long_Wait         
				movlw   d'150'                  ; No of Cycles         
				movwf   large_count 
Long_Wait_Loop         
				call    Wait_2ms         
				decfsz  large_count,1         
				goto    Long_Wait_Loop         
				return  
; ***** Beep ! *****  
Beep         
				
				SEL_BANK_1         
				bcf     TRISA,0         		; Set port A0 to output         
				SEL_BANK_0          
				movlw   d'50'           		; No of Cycles         
				movwf   large_count 
Beep_Loop         
				bcf     Piiks         
				call    Wait_2ms         
				bsf     Piiks         
				call    Wait_2ms         
				decfsz  large_count,1         
				goto    Beep_Loop         
				return  
; ***** Wait 60 usec *****  
Wait_60us         
				movlw   d'20'         
				movwf   small_count 
W60u_Loop         
				decfsz  small_count,1   		; 1         
				goto W60u_Loop          		; 2         
				return  
; ***** Wait 196 usec *****  
Wait_Bit         
				movlw   d'65'         
				movwf   small_count 
W196u_Loop         
				decfsz  small_count,1   		; 1         
				goto W196u_Loop         		; 2         
				return  
; ***** Wait 2 msec *****  
Wait_2ms         
				movlw   d'200'          		; 200 x 10us = 2000us = 2ms         
				movwf   small_count 
W1m_Loop         
				nop                     		; 1         
				nop                     		; 2         
				nop                     		; 3         
				nop                     		; 4         
				nop                     		; 5         
				nop                     		; 6         
				nop                     		; 7         
				decfsz  small_count,1   		; +1         
				goto W1m_Loop           		; +2 = 10 cycles         
				return    
; ***** TABLES ***** TABLES ***** TABLES *****                   
				org     h'0300'  
Message          
				movwf   Table_Temp         
				movlw   h'03'         
				movwf   PCLATH         
				movf    Table_Temp,W
				addwf	Messi_nr,W				; vali sobiv mess vastavalt numbrile (vt. allpool)
				addwf   PCL,F         
				dt      "KERBEROS VALVAB  "		; mes nr. 0	   	0h
				dt		"Ukseandur->alarm " 	; nr. 17       	11h
				dt		"PIRandur->alarm  " 	; nr. 33		21h+1
				dt		"Saatja patarei ! "		; nr. 49		31h+2
				dt		"Patarei thjeneb "		; nr  65		41h+3
				dt		"Levi test/alarm  "		; nr  81		51h+4
				dt		"                 "		; nr  97		61h +5(thi rida)
GraphDef         
				movwf   Table_Temp         
				movlw   h'03'         
				movwf   PCLATH         
				movf    Table_Temp,W         
				addwf   PCL,F         
				retlw   b'00000000'         
				retlw   b'00001100'         
				retlw   b'00000100'         
				retlw   b'00000100'         
				retlw   b'00000100'         
				retlw   b'00000110'         
				retlw   b'00000000'         
				retlw   0          
				retlw   b'00000000'         
				retlw   b'00000110'         
				retlw   b'00000010'         
				retlw   b'00000100'         
				retlw   b'00001000'         
				retlw   b'00001100'         
				retlw   b'00000000'         
				retlw   0                  
				retlw   b'00000000'         
				retlw   b'00000000'         
				retlw   b'00000001'         
				retlw   b'00011111'         
				retlw   b'00010000'         
				retlw   b'00000000'         
				retlw   b'00000000'         
				retlw   0                  
				retlw   b'00000000'         
				retlw   b'00000000'         
				retlw   b'00011000'         
				retlw   b'00010101'         
				retlw   b'00000011'         
				retlw   b'00000000'         
				retlw   b'00000000'         
				retlw   0  
 
; ***** Reset 16C84 *****          
				org     03FFh         
				goto    Reset_Vector ;         
	END  
